pub mod components;
pub mod models;
mod pages;

use leptos::*;
use leptos_meta::*;
use leptos_router::*;

#[component]
pub fn App() -> impl IntoView {
    provide_meta_context();

    view! {
        <Stylesheet id="leptos" href="/pkg/portfolio.css"/>
        <Link rel="shortcut icon" type_="image/ico" href="/favicon.ico"/>
        <Link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.9.0/styles/github-dark-dimmed.min.css"/>
        <script src="/js/highlight.min.js"></script>
        <script src="https://cdn.jsdelivr.net/npm/mermaid@10.6.1/dist/mermaid.min.js"></script>
        <Router>
            <Routes>
                <Route path="" view=pages::Home/>
                <Route path="posts" view=pages::PostList/>
                <Route path="posts/:slug" view=|| view! {
                    <script>
                        r#"
                            document.onreadystatechange = () => {
                                if (document.readyState === "complete") {
                                    hljs.highlightAll();
                                    mermaid.initialize();
                                    mermaid.run({ querySelector: ".language-mermaid" });
                                }
                            };
                        "#
                    </script>
                    <pages::PostElement/>
                }/>
            </Routes>
        </Router>
    }
}
